#include <windows.h>
#include <stdio.h>

BOOL Privilege(LPTSTR pszPrivilege, BOOL bEnable)
{
     HANDLE           hToken;
     TOKEN_PRIVILEGES tp;

     // obtain the token, first check the thread and then the process
     if (!OpenThreadToken(GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, TRUE, &hToken)){
          if (GetLastError() == ERROR_NO_TOKEN){
               if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
                    return FALSE;
                  }
                  else
                          return FALSE;
         }

     // get the luid for the privilege
     if (!LookupPrivilegeValue(NULL, pszPrivilege, &tp.Privileges[0].Luid)) {
          CloseHandle(hToken);
          return FALSE;
     }

     tp.PrivilegeCount = 1;

     if (bEnable)
          tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
     else
          tp.Privileges[0].Attributes = 0;

     // enable or disable the privilege
     if (!AdjustTokenPrivileges(hToken, FALSE, &tp, 0, (PTOKEN_PRIVILEGES)NULL, 0)) {
          CloseHandle(hToken);
          return FALSE;
     }

     if (!CloseHandle(hToken))
          return FALSE;

     return TRUE;
}

void print_help() {
    printf("Usage:\n"
           "  fshutdown [-<switches>]\n"
           "Exclusive switches:\n"
           "  r  reboot                      s,h  shutdown\n"
           "  l  logoff                      p    poweroff\n"
           "Optional switch:\n"
           "  f  forces processes to terminate\n");
    exit(0);
}

void main (int argc, char* argv[]) {
    ULONG Flags = 0;
    int i, j;
    char a;
    printf("Console Shutdown control utility for WIndows NT/2000/XP/.NET, v.1a\n"
           "  Copyright (c) Alexander A. Telyatbikov, 2003\n");

    for(i=1; i<argc; i++) {
        if(!argv[i])
            continue;
        if(argv[i][0] != '-') {
            print_help();
        }
        j=1;
        while((a = argv[i][j]) && (a != ' ') && (a != '\t')) {
            switch(a) {
            case '?' :
                print_help();
            case 'r' :
                Flags |= EWX_REBOOT;
                break;
            case 's' :
            case 'h' :
                Flags |= EWX_SHUTDOWN;
                break;
            case 'l' :
                Flags |= EWX_LOGOFF;
                break;
            case 'p' :
                Flags |= EWX_POWEROFF;
                break;

            case 'f' :
                Flags |= EWX_FORCE;
                break;
            }
/*            case 'F' :
                Flags |= EWX_FORCEIFHUNG;
                break;
            }*/
            j++;
        }
    }

    if(!Flags)
        print_help();
    Privilege(SE_SHUTDOWN_NAME, TRUE);
    ExitWindowsEx(Flags /*| EWX_FORCEIFHUNG*/, 0);
}
